//-------------------------------------------------------------
//   #define   
//,    
//#define EVENTINSTRUMENTATION
//-------------------------------------------------------------

//-----------------------------------------------------------------------
//,   ,     
//   - 
//-----------------------------------------------------------------------
bool m_userInterfaceUpdateOccuring;

// 
private int m_radioButton1ChangeEventCount;
private int m_textBox1ChangeEventCount;

//-----------------------------------------------------------------------------
//,       ,   
//     .   
//   ,      
//  ,   .
//-----------------------------------------------------------------------------
#if EVENTINSTRUMENTATION
private System.Collections.ArrayList m_instrumentedEventLog;
//--------------------------------------------------------------------------
//      ,  
// 
//
//:       
//       , ,    , 
//          
//--------------------------------------------------------------------------
private void instrumented_logEventOccurrence(string eventData)
{
    //  ,      
    if (m_instrumentedEventLog == null)
    {
      m_instrumentedEventLog  = 
                new System.Collections.ArrayList();
    }

    // 
    m_instrumentedEventLog.Add(eventData);
}

//---------------------------------------------------------------
//   
//:     . 
//         
//         ,   
//         .
//---------------------------------------------------------------
private void instrumentation_ShowEventLog()
{
  System.Windows.Forms.ListBox.ObjectCollection listItems;
  listItems = listBoxEventLog.Items;

  //  
  listItems.Clear();
  //   - 
  if (m_instrumentedEventLog == null)
  {
    listItems.Add("0 Events");
    return;
  }

  //    
  //  
  listItems.Add(m_instrumentedEventLog.Count.ToString() + 
                  " Events");
  //     ,   
  //   
  string logItem;
  for(int listIdx = m_instrumentedEventLog.Count - 1; 
      listIdx >= 0; listIdx--)
  {
    logItem = (string) m_instrumentedEventLog[listIdx];
    listItems.Add(logItem);
  }
}
#endif

//-------------------------------------------------------------
//    RadioButton1
//-------------------------------------------------------------
private void radioButton1_CheckedChanged
                          (object sender, System.EventArgs e)
{
  //       
  //,        ,   
  //    .    ,
  //      - .
  if(m_userInterfaceUpdateOccuring == true)
  {return;}

  //,      
  m_radioButton1ChangeEventCount++;

#if EVENTINSTRUMENTATION
  //  
instrumented_logEventOccurrence("radioButton1.Change:" + //
    m_radioButton1ChangeEventCount.ToString() + ":" + // 
    radioButton1.Checked.ToString()); //
#endif

}

//-------------------------------------------------------------
//    Button1
//    
//,       
//-------------------------------------------------------------
private void button1_Click(object sender, System.EventArgs e)
{
  //  ,    ,     
  // ,   
  // .
  
  //m_userInterfaceUpdateOccuring   = true;
  
  radioButton1.Checked = true;
  textBox1.Text = "Hello World";

  //   
  m_userInterfaceUpdateOccuring   = false;
}

//------------------------------------------------------------------
//      TextBox
//------------------------------------------------------------------
  private void textBox1_TextChanged
                            (object sender, System.EventArgs e)
{
  //       
  //,        ,   
  //    .    ,
  //      - .
  if(m_userInterfaceUpdateOccuring == true)
  {return;}

  //,      
  m_textBox1ChangeEventCount++;

#if EVENTINSTRUMENTATION
  //   
  instrumented_logEventOccurrence("textBox1.Change:" + //
    m_textBox1ChangeEventCount.ToString() + ":" +  // 
    textBox1.Text.ToString()); //
#endif
}

private void buttonShowEventLog_Click
              (object sender, System.EventArgs e)
{
#if EVENTINSTRUMENTATION
  instrumentation_ShowEventLog();
#endif  
}
