'-----------------------------------------------------------
'       PictureBox
'-----------------------------------------------------------
Private Sub Button1_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles Button1.Click

    LoadImageFromResource()
    PictureBox1.Image = m_myBitmapImage
End Sub

Private m_myBitmapImage As System.Drawing.Bitmap
'------------------------------------------------------------------
' ,      
'  
'------------------------------------------------------------------
Public Sub LoadImageFromResource()
  '   ,
  '      .
  If Not (m_myBitmapImage Is Nothing) Then
    Return
  End If

  '----------------------------------------------------
  '      
  '----------------------------------------------------
  Dim thisAssembly As System.Reflection.Assembly = _
    System.Reflection.Assembly.GetExecutingAssembly()

  '-------------------------------------------
  '  
  '-------------------------------------------
  Dim thisAssemblyName As System.Reflection.AssemblyName = _
                                thisAssembly.GetName()
  Dim assemblyName As String = thisAssemblyName.Name

  '------------------------------------------------------------------------
  '         
  '   
  '
  ':    ResourceStream   ,
  '              
  '       ,     
  '------------------------------------------------------------------------
  m_myBitmapImage = New System.Drawing.Bitmap( _
    thisAssembly.GetManifestResourceStream( _
                            assemblyName + ".MyImage.PNG"))
End Sub
