//-----------------------------------------------------------------
// ,      
//      
//-----------------------------------------------------------------
#if DEBUG_SIMULATE_FAILURES
//      
static SimulatedFailures g_failureCode = 
          SimulatedFailures.noFailurePending;  

// ,    
public enum SimulatedFailures
{
  noFailurePending,  //  ,  

  // :
  failInNextWriteSocketCode,
  failInNextWebServiceCall,
  failInNextFileIODuringFileOpen,
  failInNextFileIODuringFileRead
  //  
}   
#endif //DEBUG_SIMULATE_FAILURES

//-------------------------------------------------------------
//,      ...
//-------------------------------------------------------------
private void writeDataToSocket(
  System.Net.Sockets.Socket mySocket, 
  byte[] dataToSend)
{
  //------------------------------------------------------------------
  //        
  //------------------------------------------------------------------
#if DEBUG_SIMULATE_FAILURES
//  ,    ,  
if (g_failureCode == 
SimulatedFailures.failInNextWriteSocketCode)
{
  //  ,    
  //    
  g_failureCode  = SimulatedFailures.noFailurePending; 

  throw new Exception("Test communications failure: " + 
            g_failureCode.ToString());
}
#endif

  //   ...
  mySocket.Send(dataToSend);
} // 
