Option Strict On
Imports System

Public Class LessWastefulWorkerClass
Private m_beginning_segment As String
Public Property BeginSegment() As String
  Get
    Return m_beginning_segment
  End Get
  Set(ByVal Value As String)
    m_beginning_segment = Value
  End Set
End Property

Private m_middle_segment As String
Public Property MiddleSegment() As String
  Get
    Return m_middle_segment
  End Get
  Set(ByVal Value As String)
    m_middle_segment = Value
  End Set
End Property

Private m_end_segment As String
Public Property EndSegment() As String
  Get
    Return m_end_segment
  End Get
  Set(ByVal Value As String)
    m_end_segment = Value
  End Set
End Property

Public Sub ReuseClass(ByVal in_word As String)
  '----------------------------------------------
  '    
  '   
  '----------------------------------------------
  m_beginning_segment = ""
  m_middle_segment = ""
  m_end_segment = ""

  Dim index_segment1 As Integer

  '    ("_")  
  index_segment1 = in_word.IndexOf("_", 0)

  '    "_" ,   ,   
  If (index_segment1 = -1) Then
    m_beginning_segment = in_word
    Return

  Else '   "_",   

    If (index_segment1 = 0) Then
    Else

      m_beginning_segment = in_word.Substring(0, _
                                  index_segment1)
    End If

    Dim index_segment2 As Integer
    index_segment2 = in_word.IndexOf("_", index_segment1 + 1)

    If (index_segment2 = -1) Then
      m_end_segment = in_word.Substring(index_segment1 + 1)
      Return
    End If

    '  
    m_middle_segment = in_word.Substring(index_segment1 + 1, _
                          index_segment2 - index_segment1 - 1)
    m_end_segment = in_word.Substring(index_segment2 + 1)

  End If
End Sub

Public Function getWholeString() As String

  Return m_beginning_segment + "_" + m_middle_segment + "_" + _
                                      m_end_segment
End Function
End Class
