const int COUNT_UNTIL = 300;
const int LOOP_ITERATIONS = 40;

//---------------------------------------------------------
//   !
//
//       
// 
//---------------------------------------------------------
private void button1_Click(object sender, System.EventArgs e)
{
  //  ,  
  //   .
  //       ! 
  //      
  //    !
  System.GC.Collect();
  int numberToStore = 0;

  PerformanceSampling.StartSample(0, "StringAllocaitons");
  string total_result = "";
  for (int outer_loop = 0; outer_loop < LOOP_ITERATIONS; 
        outer_loop++)
  {
    //  
    total_result = "";
	
    //     x_counter, 
    //       
    for(int x_counter = 0; x_counter < COUNT_UNTIL; x_counter++)
    {
      total_result = total_result + numberToStore.ToString()
                     + ", ";

      //  
      numberToStore ++;
    }
  }
  PerformanceSampling.StopSample(0);

  //  
  System.Windows.Forms.MessageBox.Show(" : " + 
                          total_result.Length.ToString());

  // 
  System.Windows.Forms.MessageBox.Show(" : " + 
                          total_result);


  //   ,   
  System.Windows.Forms.MessageBox.Show(
          PerformanceSampling.GetSampleDurationText(0));
}

//---------------------------------------------------------
//   !
//
//       
// StringBuilder
//---------------------------------------------------------
private void button2_Click(object sender, System.EventArgs e)
{
  //  ,  
  //   .
  //       ! 
  //       
  //    !
  System.GC.Collect();
  System.Text.StringBuilder sb = 
        new System.Text.StringBuilder();

  string total_result = "";
  int numberToStore = 0;

  PerformanceSampling.StartSample(1, "StringBuilder");
  for (int outer_loop = 0; outer_loop < LOOP_ITERATIONS; 
        outer_loop++)
  {
    //  StringBuilder (   )
    sb.Length = 0;
    //    
    total_result = "";

    //     x_counter,   
    //      
    for(int x_counter = 0; x_counter < COUNT_UNTIL; x_counter++)
    {
      sb.Append(numberToStore );
      sb.Append(", ");

      //  
      numberToStore ++;
    }
    //     ...
    total_result = sb.ToString();
  }

  PerformanceSampling.StopSample(1);

  //  
  System.Windows.Forms.MessageBox.Show(" : " 
                  + total_result.Length.ToString());

  // 
  System.Windows.Forms.MessageBox.Show("String : " 
                  + total_result);

  //   ,   
  System.Windows.Forms.MessageBox.Show(
          PerformanceSampling.GetSampleDurationText(1));
}
