Const COUNT_UNTIL As Integer = 300
Const LOOP_ITERATIONS As Integer = 40
'---------------------------------------------------------
'   !
'
'       
' 
'---------------------------------------------------------
  Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button1.Click

  '  ,  
  '   .
  '       ! 
  '        
  '  !
  System.GC.Collect()
  Dim numberToStore As Integer

  PerformanceSampling.StartSample(0, "StringAllocaitons")
  Dim total_result As String
  Dim outer_loop As Integer
  For outer_loop = 1 To LOOP_ITERATIONS
    '  
    total_result = ""

    '     x_counter,   
    '      
    Dim x_counter As Integer
    For x_counter = 1 To COUNT_UNTIL
      total_result = total_result + numberToStore.ToString() _
                     + ", "

      '  
      numberToStore = numberToStore + 1
    Next
  Next
  PerformanceSampling.StopSample(0)

  '  
  MsgBox("String Length: " + total_result.Length.ToString())
  ' 
  MsgBox("String : " + total_result)
  '   ,     
  MsgBox(PerformanceSampling.GetSampleDurationText(0))
End Sub

'-------------------------------------------------------
'   !
'
'       
'  (String Builder)
'-------------------------------------------------------
Private Sub Button2_Click(ByVal sender As System.Object, _
         ByVal e As System.EventArgs) Handles Button2.Click
  '  ,  
  '   .
  '       ! 
  '        
  '  !
  System.GC.Collect()
  Dim sb As System.Text.StringBuilder = _
        New System.Text.StringBuilder

  Dim total_result As String
  Dim numberToStore As Integer

  PerformanceSampling.StartSample(1, "StringBuilder")
  Dim outer_loop As Integer
  For outer_loop = 1 To LOOP_ITERATIONS

    '  
    sb.Length = 0
    '    
    total_result = ""

    '     x_counter,   
    '      
    Dim x_counter As Integer
    For x_counter = 1 To COUNT_UNTIL
      sb.Append(numberToStore)
      sb.Append(", ")

      '  
      numberToStore = numberToStore + 1
    Next
    '     ...
    total_result = sb.ToString()
  Next

  PerformanceSampling.StopSample(1)

  '  
  MsgBox(" : " + total_result.Length.ToString())
  ' 
  MsgBox("String : " + total_result)
  '   ,   
  MsgBox(PerformanceSampling.GetSampleDurationText(1))
End Sub
