'       
Const dummy_node As String = "_dummynode"
',       
Const node_needToBePopulated As String = "_populateMe"
',         
Const nodeText_Neighborhoods As String = "Neighborhoods"
Const nodeText_Prices As String = "Prices"
Const nodeText_HouseType As String = "HouseTypes"

'--------------------------------------------------------------------
'    
'
'    TreeView   
'  
'--------------------------------------------------------------------

Private Sub Button1_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles Button1.Click

  Dim tnNewNode As TreeNode

  '     ,     
  TreeView1.BeginUpdate()
  '   
  TreeView1.Nodes.Clear()

  '-----------------------------
  ' "Neighborhoods"
  '-----------------------------
  '  "Neighborhoods"  .
  tnNewNode = TreeView1.Nodes.Add("Neighborhoods")

  '   ,   ,   
  '  
  tnNewNode.Tag = node_needToBePopulated
  '       ,  
  ' ,   ,      
  ' .
  tnNewNode.Nodes.Add(dummy_node)

  '-----------------------------
  ' "Price"
  '-----------------------------
  tnNewNode = TreeView1.Nodes.Add("Price")

  '   ,   ,   
  '  
  tnNewNode.Tag = node_needToBePopulated

  '       ,  
  ' ,   ,      
  ' .
  tnNewNode.Nodes.Add(dummy_node)

  '-----------------------------
  ' "HouseType"
  '-----------------------------
  tnNewNode = TreeView1.Nodes.Add("HouseType")

  '   ,   ,   
  '  
  tnNewNode.Tag = node_needToBePopulated

  '       ,  
  ' ,   ,      
  ' .
  tnNewNode.Nodes.Add(dummy_node)

  '  
  TreeView1.EndUpdate()
End Sub

''-----------------------------------------------------------------------------
''  BeforeExpand     TreeView
'':    C#,  
''            
''      "InitializeComponent()" (  !)
''            
''           VB
''
''     ,   ,
''  ,   .     
''          
''   TreeView.
''-----------------------------------------------------------------------------
Private Sub TreeView1_BeforeExpand(ByVal sender As Object, _
    ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) _
    Handles TreeView1.BeforeExpand

' ,   
Dim tnExpanding As System.Windows.Forms.TreeNode
tnExpanding = e.Node

'     "   ",
'      , "  ".  
If Not (tnExpanding.Tag Is node_needToBePopulated) Then
    Return '   
End If

'------------------------------------------------------------
'    .
' ,      ; ,
'   
'------------------------------------------------------------
If (tnExpanding.Text = nodeText_Neighborhoods) Then
    PopulateTreeViewNeighborhoods(tnExpanding)
  Return 'done adding items!
Else
  '     ,   
  '.
  MsgBox(" :       ")

  '    ,       
  ' 
  tnExpanding.Tag = ""
End If
End Sub

'------------------------------------------------------------------
'       
'  "Neighborhood"
'------------------------------------------------------------------
Sub PopulateTreeViewNeighborhoods(ByVal tnAddTo As TreeNode)
  Dim tvControl As TreeView
  tvControl = tnAddTo.TreeView

  tvControl.BeginUpdate()
  '   
  tnAddTo.Nodes.Clear()

  '  ,      
  ' ,   .
  Dim newNeighborhoodNodes() As TreeNode
  ReDim newNeighborhoodNodes(3)
  newNeighborhoodNodes(0) = New TreeNode("Capitol Hill")
  newNeighborhoodNodes(1) = New TreeNode("Chelsea")
  newNeighborhoodNodes(2) = New TreeNode("Downtown")
  newNeighborhoodNodes(3) = New TreeNode("South Bay")
  '      TreeView
  tnAddTo.Nodes.AddRange(newNeighborhoodNodes)

  tvControl.EndUpdate()
End Sub
