' DataSet,    
Private m_myDataSet As System.Data.DataSet
',   
Const FILE_EMPTY_DATASET As String = "EmptyDataSet.xml"
Const FILE_1TABLE_DATASET As String = "1TableDataSet.xml"
Const dividerLine As String = _
      "-----------------------------" + vbCrLf

'----------------------------------------------------------
'       ,
'    textBox1
'----------------------------------------------------------
Private Sub addFileContentsToTextBox(ByVal fileName As String)
  '     
  Dim myStreamReader As System.IO.StreamReader
  myStreamReader = System.IO.File.OpenText(fileName)
  Dim fileText As String = myStreamReader.ReadToEnd()
  ' 
  myStreamReader.Close()

  '   ,    
  TextBox1.Text = TextBox1.Text + _
    dividerLine + "FILE: '" + fileName + "'" + vbCrLf + _
    dividerLine + fileText + vbCrLf
End Sub

'----------------------------------------------------------
'1.   ,
'        XML, 
'       
'
'2.      ,
'         ,
'        ,
'        XML, 
'       
'----------------------------------------------------------
Private Sub Button1_Click(ByVal sender As System.Object, _
          ByVal e As System.EventArgs) Handles Button1.Click

  '    
  TextBox1.Text = ""
  '===========================================
  '1.     
  '===========================================
  m_myDataSet = New System.Data.DataSet("HelloWorld-DataSet")

  '  ADO.NET DataSet   XML  
  '   
  m_myDataSet.WriteXml(FILE_EMPTY_DATASET)
  addFileContentsToTextBox(FILE_EMPTY_DATASET)

  '==================================================
  '2.       ADO.NET,
  '     2     
  '==================================================
  Dim myTestTable As System.Data.DataTable
  myTestTable = m_myDataSet.Tables.Add("TestTable")

  '------------------------------------
  ' 2   
  '------------------------------------
  '     DataTable  DataSet
  myTestTable.Columns.Add("TestColumn0", _
                          GetType(System.DateTime))
  '     DataTable  DataSet
  myTestTable.Columns.Add("TestColumn1", GetType(String))

  '------------------------------------
  '    
  '------------------------------------
  '     
  Dim rowOfData() As Object
  ReDim rowOfData(1)
  ' 0 -   
  rowOfData(0) = System.DateTime.Today
  ' 1 -   
  rowOfData(1) = "a string of data today"
  myTestTable.Rows.Add(rowOfData)

  '      
  Dim rowOfData2() As Object
  ReDim rowOfData2(1)
  ' 0 -   
  rowOfData2(0) = System.DateTime.Today.AddDays(1)

  ' 1 -   
  rowOfData2(1) = "tomorrow's string"
  myTestTable.Rows.Add(rowOfData2)

  '   ADO.NET DataSet   XML  
  '   
  m_myDataSet.WriteXml(FILE_1TABLE_DATASET)
  addFileContentsToTextBox(FILE_1TABLE_DATASET)
End Sub
