'-------------------------------------------------------------
'     Web-
'      
'[in] httpWhereFrom: URL- 
'     (, "http://someserver/somefile.jpg")
'[in] filenameWhereTo: ,    
'     (, "\\localfile.jpg")
'-------------------------------------------------------------
Public Sub downloadFileToLocalStore(ByVal httpWhereFrom As _
  String, ByVal filenameWhereTo As String)
  Dim myFileStream As System.IO.FileStream = Nothing
  Dim myHTTPResponseStream As System.IO.Stream = Nothing
  Dim myWebRequest As System.Net.WebRequest = Nothing
  Dim myWebResponse As System.Net.WebResponse = Nothing

  ' ,    ,  ,  
  If (System.IO.File.Exists(filenameWhereTo) = True) Then
      System.IO.File.Delete(filenameWhereTo)
  End If

  Try
    ' Web-
    myWebRequest = _
      System.Net.HttpWebRequest.Create(httpWhereFrom)
    ' 
    myWebResponse = myWebRequest.GetResponse()
    '   
    myHTTPResponseStream = myWebResponse.GetResponseStream()

    '  ,      
    myFileStream = System.IO.File.OpenWrite(filenameWhereTo)

    '     
    Const buffer_length As Integer = 4000
    Dim byteBuffer() As Byte
    ReDim byteBuffer(buffer_length)
    Dim bytesIn As Integer

    '        
    Do
      ' 
      bytesIn = myHTTPResponseStream.Read(byteBuffer, _
        0, buffer_length)

      ' 
      If (bytesIn <> 0) Then
        myFileStream.Write(byteBuffer, 0, bytesIn)
      End If
    Loop While (bytesIn <> 0)

  Catch myException As Exception  '  !
      '- .  
    attemptCleanup_ThrowNoExceptions(myFileStream, _
        myHTTPResponseStream, myWebResponse)

    ',   ,   ,
    '    ,   !
    Throw myException
  End Try

  '  !

  '  .
  Try
    '   .
    myFileStream.Close()
    myFileStream = Nothing

    myHTTPResponseStream.Close()
    myHTTPResponseStream = Nothing

    myWebResponse.Close()
    myWebResponse = Nothing
  Catch myException As Exception  '    !
    '- .  
    attemptCleanup_ThrowNoExceptions(myFileStream, _
          myHTTPResponseStream, myWebResponse)

    ',   ,   ,
    '    ,   !
    Throw myException
  End Try
  ' !
End Sub

'----------------------------------------------
'     
'   .
'----------------------------------------------
Sub attemptCleanup_ThrowNoExceptions( _
  ByVal myFileStream As System.IO.FileStream, _
  ByVal myHTTPResponseStream As System.IO.Stream, _
  ByVal myWebResponse As System.Net.WebResponse)

  If Not (myFileStream Is Nothing) Then
    Try
      myFileStream.Close()
    Catch '   .
    End Try
  End If

  If Not (myHTTPResponseStream Is Nothing) Then
    Try
      myHTTPResponseStream.Close()
    Catch '   . 
    End Try
  End If

  If Not (myWebResponse Is Nothing) Then
    Try
      myWebResponse.Close()
    Catch '   . 
    End Try
  End If
End Sub
