//,      IrDA
const string myIrDASocketName = "IrDaTestFileTransmit";

private void buttonTestFileSend_Click(object sender, 
                                      System.EventArgs e)
{
  //   ,    
  const string fileName = "\\myTestSendFile.txt";
  System.IO.StreamWriter textFileStream;
  textFileStream = System.IO.File.CreateText(fileName);
  textFileStream.WriteLine("Today...");
  textFileStream.WriteLine("is a nice day");
  textFileStream.WriteLine("to go swim");
  textFileStream.WriteLine("in the lake");
  textFileStream.Close();

  IrDAFileSend irdaFileSend;
  irdaFileSend = new IrDAFileSend(fileName, myIrDASocketName);
  // 2 : 1 - Sync (), 2 - Async ()

  //1.     
  //      ,
  //    

  //1a.     
  //      ,
  //    
  this.Text = "Trying to send...";
  //1b. ,     ,    
  irdaFileSend.LoopAndAttemptIRSend(); 
  //1c.    ,   
  System.Windows.Forms.MessageBox.Show("File sent!");
  this.Text = "IrDA: Sent!";

  //2.       
  //   

  //irdaFileSend.LoopAndAttemptIRSendAsync();
  //:       ,  
  // ,     , 
  //  'irdaFileSend.Status'
}

private void buttonTestFileReceive_Click(object sender, 
                                         System.EventArgs e)
{
  //    ,  
  const string fileName = "\\myTestReceiveFile.txt";
  if (System.IO.File.Exists(fileName))
  {
    System.IO.File.Delete(fileName);
  }

  IrDAFileReceive irdaFileReceive;
  irdaFileReceive = new IrDAFileReceive(fileName, 
                                        myIrDASocketName);
  // 2 : 1 - Sync (), 2 - Async ()

  //1.     
  //      ,
  //    

  //1a.    ,     
  this.Text = "Waiting to receive...";
  //1b. ,         
  //  
  irdaFileReceive.WaitForIRFileDownload();
  //1c.    ,     
  this.Text = "IrDA: received!";
  System.Windows.Forms.MessageBox.Show("File received!");

  //2.       
  //   

  //irdaFileReceive.WaitForIRFileDownloadAsync();
  //:       ,  
  // ,     , 
  //  'irdaFileReceive.Status'
}
