',      IrDA
Const myIrDASocketName As String = "IrDaTestFileTransmit"

Private Sub buttonTestFileSend_Click(ByVal sender As Object, _
  ByVal e As System.EventArgs) Handles buttonTestFileSend.Click

  '   ,    
  Const fileName As String = "\myTestSendFile.txt"
  Dim textFileStream As System.IO.StreamWriter
  textFileStream = System.IO.File.CreateText(fileName)
  textFileStream.WriteLine("Today...")
  textFileStream.WriteLine("is a nice day")
  textFileStream.WriteLine("to go swim")
  textFileStream.WriteLine("in the lake")
  textFileStream.Close()

  Dim irdaFileSender As IrDAFileSend
  irdaFileSender = New IrDAFileSend(fileName, myIrDASocketName)
  ' 2 : 1 - Sync (), 2 - Async ()

  '1.     
  '      ,
  '    

  '1a.    ,     
  Me.Text = "Trying to send..."
  ',     ,    
  irdaFileSender.LoopAndAttemptIRSend()

  '1c.    ,   
  MsgBox("File sent!")
  Me.Text = "IrDA: Sent!"

  '2.       
  '   

  'irdaFileSend.LoopAndAttemptIRSendAsync()
  ':       ,  
  ' ,     , 
  '  'irdaFileSend.Status'
End Sub

Private Sub buttonTestFileReceive_Click(ByVal sender As Object _
, ByVal e As EventArgs) Handles buttonTestFileReceive.Click

  '    ,  
  Const fileName As String = "\myTestReceiveFile.txt"
  If (System.IO.File.Exists(fileName)) Then
      System.IO.File.Delete(fileName)
  End If

  Dim irdaFileReceiver As IrDAFileReceive
  irdaFileReceiver = New IrDAFileReceive(fileName, _
                                        myIrDASocketName)
  ' 2 : 1 - Sync (), 2 - Async ()

  '1.     
  '      ,  
  '   

  '1a.    ,     
  Me.Text = "Waiting to receive..."
  '1b. ,         
  '  
  irdaFileReceiver.WaitForIRFileDownload()
  '1c.    ,     
  Me.Text = "IrDA: received!"
  MsgBox("File received!")

  '2.       
  '   

  'irdaFileReceive.WaitForIRFileDownloadAsync()
  ':       ,  
  ' ,     , 
  '  'irdaFileReceive.Status'
End Sub
