//------------------------------------------------------
//       Form1.cs
//------------------------------------------------------

//,      
FindNextPrimeNumber m_findNextPrimeNumber;
//---------------------------------------------------------
// ,   ...
//---------------------------------------------------------
void setCalculationStatusText(string text)
{
  label1.Text = text;
}

//---------------------------------------------------------
//   ""  
//---------------------------------------------------------
private void menuItemExit_Click(object sender, 
                                System.EventArgs e)
{
  this.Close();    
}

//---------------------------------------------------------
//     
//---------------------------------------------------------
private void menuItemStart_Click(object sender, 
  System.EventArgs e)
{
  //,      
  long startNumber = System.Convert.ToInt64(textBox1.Text);
  //  
  m_findNextPrimeNumber = new FindNextPrimeNumber(startNumber);

  //     
  m_findNextPrimeNumber.findNextHighestPrime_Async();

  // ,     
  timer1.Interval = 400; //400 
  timer1.Enabled = true;
}

//---------------------------------------------------------
//   ""  
//---------------------------------------------------------
private void menuItemAbort_Click(object sender,
                                 System.EventArgs e)
{
  //  ,     
  if(m_findNextPrimeNumber == null) return;

  //     
  m_findNextPrimeNumber.setProcessingState(
    FindNextPrimeNumber.ProcessingState.requestAbort);

  //  
  //   ...
  setCalculationStatusText("Waiting to abort...");
  //  setCalculationStatusText("  ...");
}

//-------------------------------------------------------------
// ,    ,
//   
// 
//-------------------------------------------------------------
private void timer1_Tick(object sender, System.EventArgs e)
{
  //       
  //  ,  
  if (m_findNextPrimeNumber == null)
  {
    timer1.Enabled = false;
    return;
  }

  //-------------------------------------------------
  //   ,  ,
  // ,   
  //-------------------------------------------------
  if (m_findNextPrimeNumber.getProcessingState ==
    FindNextPrimeNumber.ProcessingState.aborted)
  {
    timer1.Enabled = false;
    m_findNextPrimeNumber = null;
    setCalculationStatusText("Prime search aborted");
    // setCalculationStatusText("   ");
    return;
  }

  //--------------------------------------------
  //    ?
  //--------------------------------------------
  if (m_findNextPrimeNumber.getProcessingState ==
    FindNextPrimeNumber.ProcessingState.foundPrime)
  {
    timer1.Enabled = false;
    
    // 
    setCalculationStatusText("Found! Next Prime = " + 
      m_findNextPrimeNumber.getPrime().ToString());
    // setCalculationStatusText(" !    = " + 
    //   m_findNextPrimeNumber.getPrime().ToString());

    m_findNextPrimeNumber = null;

    return;
  }

  //--------------------------------------------
  // . 
  //   
  //--------------------------------------------
  //   
  long numberCalculationsToFar;
  long currentItem;
  m_findNextPrimeNumber.getExecutionProgressInfo(
    out numberCalculationsToFar, out currentItem);
  setCalculationStatusText("In progress. Looking at: " +
    currentItem.ToString() + ". " +
    numberCalculationsToFar.ToString() +
    " calculations done for you so far!");
  // setCalculationStatusText(" .   : " +
  //   currentItem.ToString() + ". " +
  //   "   " +    
  //   numberCalculationsToFar.ToString() +
  //   " !");
}
